package com.ktg.iscs.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ktg.iscs.domain.IsWorkarea;
import com.ktg.iscs.domain.vo.workarea.PageWorkareaVO;
import com.ktg.iscs.domain.vo.workarea.PointsMapVO;

import java.util.List;

/**
 * 工作区域Service接口
 *
 * @author cgj
 * @date 2024-10-18
 */
public interface IIsWorkareaService extends IService<IsWorkarea>
{
    /**
     * 查询工作区域
     *
     * @param workareaId 工作区域主键
     * @return 工作区域
     */
    IsWorkarea selectIsWorkareaByWorkareaId(Long workareaId);

    /**
     * 查询工作区域列表
     *
     * @param isWorkarea 工作区域
     * @return 工作区域集合
     */
    List<IsWorkarea> selectIsWorkareaList(IsWorkarea isWorkarea);

    /**
     * 新增工作区域
     *
     * @param isWorkarea 工作区域
     * @return 结果
     */
    int insertIsWorkarea(IsWorkarea isWorkarea);

    /**
     * 修改工作区域
     *
     * @param isWorkarea 工作区域
     * @return 结果
     */
    int updateIsWorkarea(IsWorkarea isWorkarea);

    /**
     * 批量删除工作区域
     *
     * @param workareaIds 需要删除的工作区域主键集合
     * @return 结果
     */
    int deleteIsWorkareaByWorkareaIds(String workareaIds);

    /**
     * 删除工作区域信息
     *
     * @param workareaId 工作区域主键
     * @return 结果
     */
    int deleteIsWorkareaByWorkareaId(Long workareaId);

    Page<PageWorkareaVO> getIsWorkareaPage(Page page, IsWorkarea dto);

    /**
     * 获取区域map解析数据
     *
     * @param workareaId 工作区域主键
     * @return 工作区域
     */
    List<PointsMapVO> selectIsWorkareaMapById(Long workareaId, Long sopId, Long ticketId);
}
